> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://docku.mertani.com/llms.txt.
> For full documentation content, see https://docku.mertani.com/llms-full.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://docku.mertani.com/_mcp/server.

# Get device sensor data

GET https://app.mertani.co.id/external/v1/devices/{device_id}/data

Reference: https://docku.mertani.com/api-reference/external-api/get-device-sensor-data

## OpenAPI Specification

```yaml
openapi: 3.1.0
info:
  title: external-api
  version: 1.0.0
paths:
  /devices/{device_id}/data:
    get:
      operationId: get-device-sensor-data
      summary: Get device sensor data
      tags:
        - ''
      parameters:
        - name: device_id
          in: path
          required: true
          schema:
            type: string
        - name: start
          in: query
          required: true
          schema:
            type: string
            format: date-time
        - name: end
          in: query
          required: true
          schema:
            type: string
            format: date-time
        - name: tz
          in: query
          required: false
          schema:
            type: integer
        - name: Authorization
          in: header
          description: Basic authentication
          required: true
          schema:
            type: string
      responses:
        '200':
          description: Success
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/getDeviceSensorData_Response_200'
servers:
  - url: https://app.mertani.co.id/external/v1
components:
  schemas:
    Sensor:
      type: object
      properties:
        id:
          type: string
        value:
          type: number
          format: double
        unit:
          type: string
      title: Sensor
    DevicesDeviceIdDataGetResponsesContentApplicationJsonSchemaDataItems:
      type: object
      properties:
        timestamp:
          type: string
        sensors:
          type: array
          items:
            $ref: '#/components/schemas/Sensor'
      title: DevicesDeviceIdDataGetResponsesContentApplicationJsonSchemaDataItems
    getDeviceSensorData_Response_200:
      type: object
      properties:
        message:
          type: string
        data:
          type: array
          items:
            $ref: >-
              #/components/schemas/DevicesDeviceIdDataGetResponsesContentApplicationJsonSchemaDataItems
      title: getDeviceSensorData_Response_200
  securitySchemes:
    basicAuth:
      type: http
      scheme: basic

```

## SDK Code Examples

```python
import requests

url = "https://app.mertani.co.id/external/v1/devices/device-12345/data"

querystring = {"start":"2024-06-01T00:00:00Z","end":"2024-06-01T23:59:59Z","tz":"7"}

payload = {}
headers = {
    "Content-Type": "application/json"
}

response = requests.get(url, json=payload, headers=headers, params=querystring, auth=("<username>", "<password>"))

print(response.json())
```

```javascript
const url = 'https://app.mertani.co.id/external/v1/devices/device-12345/data?start=2024-06-01T00%3A00%3A00Z&end=2024-06-01T23%3A59%3A59Z&tz=7';
const credentials = btoa("<username>:<password>");

const options = {
  method: 'GET',
  headers: {
    Authorization: `Basic ${credentials}`,
    'Content-Type': 'application/json'
  },
  body: '{}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://app.mertani.co.id/external/v1/devices/device-12345/data?start=2024-06-01T00%3A00%3A00Z&end=2024-06-01T23%3A59%3A59Z&tz=7"

	payload := strings.NewReader("{}")

	req, _ := http.NewRequest("GET", url, payload)

	req.SetBasicAuth("<username>", "<password>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://app.mertani.co.id/external/v1/devices/device-12345/data?start=2024-06-01T00%3A00%3A00Z&end=2024-06-01T23%3A59%3A59Z&tz=7")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Get.new(url)
request.basic_auth("<username>", "<password>")
request["Content-Type"] = 'application/json'
request.body = "{}"

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.get("https://app.mertani.co.id/external/v1/devices/device-12345/data?start=2024-06-01T00%3A00%3A00Z&end=2024-06-01T23%3A59%3A59Z&tz=7")
  .basicAuth("<username>", "<password>")
  .header("Content-Type", "application/json")
  .body("{}")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('GET', 'https://app.mertani.co.id/external/v1/devices/device-12345/data?start=2024-06-01T00%3A00%3A00Z&end=2024-06-01T23%3A59%3A59Z&tz=7', [
  'body' => '{}',
  'headers' => [
    'Content-Type' => 'application/json',
  ],
    'auth' => ['<username>', '<password>'],
]);

echo $response->getBody();
```

```csharp
using RestSharp;
using RestSharp.Authenticators;

var client = new RestClient("https://app.mertani.co.id/external/v1/devices/device-12345/data?start=2024-06-01T00%3A00%3A00Z&end=2024-06-01T23%3A59%3A59Z&tz=7");
client.Authenticator = new HttpBasicAuthenticator("<username>", "<password>");
var request = new RestRequest(Method.GET);

request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let credentials = Data("<username>:<password>".utf8).base64EncodedString()

let headers = [
  "Authorization": "Basic \(credentials)",
  "Content-Type": "application/json"
]
let parameters = [] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://app.mertani.co.id/external/v1/devices/device-12345/data?start=2024-06-01T00%3A00%3A00Z&end=2024-06-01T23%3A59%3A59Z&tz=7")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "GET"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```